#include "stdafx.h"
#include "..\8055N++.h"
#include "K8055D.h"


/////////////////// Global variables //////////////////////////////////////////

std::shared_ptr<HID::C8055NClientDevice2> g_pDevice; //the currently active device


/////////////////// Implementation ////////////////////////////////////////////

#define CHECK_DEVICE_IS_CREATED()                           \
if (!g_pDevice)                                             \
  g_pDevice = std::make_shared<HID::C8055NClientDevice2>(); \

BOOL WINAPI DllMain(_In_ HMODULE /*hModule*/, _In_ DWORD /*dwReason*/, _In_opt_ LPVOID /*lpReserved*/)
{
    return TRUE;
}

K8055DAPI int WINAPI SearchDevices()
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->SearchDevices();
}

K8055DAPI int WINAPI SetCurrentDevice(_In_ int nCardNumber)
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->SetCurrentDevice(nCardNumber);
}

K8055DAPI int WINAPI OpenDevice(_In_ int nCardNumber)
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->OpenDevice(nCardNumber);
};

K8055DAPI void WINAPI CloseDevice()
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->CloseDevice();
}

K8055DAPI int WINAPI ReadAnalogChannel(_In_ int nChannel)
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->ReadAnalogChannel(nChannel);
}

K8055DAPI void WINAPI ReadAllAnalog(_Inout_ int* pData1, _Inout_ int* pData2)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ReadAllAnalog(pData1, pData2);
}

K8055DAPI void WINAPI OutputAnalogChannel(_In_ int nChannel, _In_ int nData)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->OutputAnalogChannel(nChannel, nData);
}

K8055DAPI void WINAPI OutputAllAnalog(_In_ int nData1, _In_ int nData2)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->OutputAllAnalog(nData1, nData2);
}

K8055DAPI void WINAPI ClearAnalogChannel(_In_ int nChannel)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ClearAnalogChannel(nChannel);
}

K8055DAPI void WINAPI ClearAllAnalog()
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ClearAllAnalog();
}

K8055DAPI void WINAPI SetAnalogChannel(_In_ int nChannel)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->SetAnalogChannel(nChannel);
}

K8055DAPI void WINAPI SetAllAnalog()
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->SetAllAnalog();
}

K8055DAPI void WINAPI WriteAllDigital(_In_ int nData)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->WriteAllDigital(nData);
}

K8055DAPI void WINAPI ClearDigitalChannel(_In_ int nChannel)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ClearDigitalChannel(nChannel);
}

K8055DAPI void WINAPI ClearAllDigital()
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ClearAllDigital();
}

K8055DAPI void WINAPI SetDigitalChannel(_In_ int nChannel)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->SetDigitalChannel(nChannel);
}

K8055DAPI void WINAPI SetAllDigital()
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->SetAllDigital();
}

K8055DAPI _Success_(return != FALSE) BOOL WINAPI ReadDigitalChannel(_In_ int nChannel)
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->ReadDigitalChannel(nChannel);
}

K8055DAPI int WINAPI ReadAllDigital()
{
  CHECK_DEVICE_IS_CREATED();

 return g_pDevice->ReadAllDigital();
}

K8055DAPI int WINAPI ReadCounter(_In_ int nCounter)
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->ReadCounter(nCounter);
}

K8055DAPI int WINAPI ReadCounter16(_In_ int nCounter)
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->ReadCounter16(nCounter);
}

K8055DAPI void WINAPI ReadAll(_Inout_updates_(8) BYTE* pData)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ReadAll(pData);
}

K8055DAPI void WINAPI ResetCounter(_In_ int nCounter)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ResetCounter(nCounter);
}

K8055DAPI void WINAPI SetCounterDebounceTime(_In_ int nCounter, _In_ int nDebounceTime)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->SetCounterDebounceTime(nCounter, nDebounceTime);
}

K8055DAPI _Success_(return != FALSE) BOOL WINAPI Connected()
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->Connected();
}

K8055DAPI void WINAPI SetPWM(_In_ int nChannel, _In_ int nData, _In_ int nFrequency)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->SetPWM(nChannel, nData, nFrequency);
}

K8055DAPI void WINAPI ReadBackAnalogOut(_Inout_updates_(2) int* pBuffer)
{
  CHECK_DEVICE_IS_CREATED();

  g_pDevice->ReadBackAnalogOut(pBuffer);
}

K8055DAPI int WINAPI ReadBackDigitalOut()
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->ReadBackDigitalOut();
}

K8055DAPI int WINAPI Version()
{
  return 0x05000004;
}

K8055DAPI int WINAPI CardVersion()
{
  CHECK_DEVICE_IS_CREATED();

  return g_pDevice->CardVersion();
}
